﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Core;

namespace HeuristicLab.Problems.GeneralizedQuadraticAssignment {
  public static class GQAPSolutionArchiveUpdater {
    public static ItemList<GQAPSolution> GetFeasibleParetoFront(IEnumerable<GQAPSolution> solutions) {
      var front = new ItemList<GQAPSolution>(solutions.Where(x => x.OverbookedCapacity.Value <= 0.0));

      for (int i = 0; i < front.Count - 1; i++) {
        for (int j = i + 1; j < front.Count; j++) {
          if (front[i].FlowDistanceQuality.Value <= front[j].FlowDistanceQuality.Value
            && front[i].InstallationQuality.Value <= front[j].InstallationQuality.Value) {
            front.RemoveAt(j);
            j--;
          } else if (front[i].FlowDistanceQuality.Value >= front[j].FlowDistanceQuality.Value
            && front[i].InstallationQuality.Value >= front[j].InstallationQuality.Value) {
            front.RemoveAt(i);
            j = i;
          }
        }
      }
      return front;
    }
  }
}
